/*
 * o2cb_err.c:
 * This file is automatically generated; please do not edit it.
 */

#include <stdlib.h>

static const char * const text[] = {
		"Invalid name for a cluster",
		"Memory allocation failed",
		"I/O error on channel",
		"Unable to access cluster service",
		"Internal logic failure",
		"Insufficient permissions to access cluster service",
		"Cluster already exists",
		"Node already exists",
		"Heartbeat region already exists",
		"Heartbeat region in use",
		"Block size is invalid",
		"Block count is invalid",
		"Could not determine local host name",
		"Configuration error discovered",
		"Node number is invalid",
		"Node manager kernel module is not loaded",
		"Could not access heartbeat region semaphore set",
		"Region semaphore set destroyed",
		"Revision of OCFS2-Tools is out of date.",
    0
};

struct error_table {
    char const * const * msgs;
    long base;
    int n_msgs;
};
struct et_list {
    struct et_list *next;
    const struct error_table * table;
};
extern struct et_list *_et_list;
extern int              et_list_lock();
extern int              et_list_unlock();

const struct error_table et_o2cb_error_table = { text, -1485349888L, 19 };

static struct et_list link = { 0, 0 };

void initialize_o2cb_error_table_r(struct et_list **list);
void initialize_o2cb_error_table(void);

void initialize_o2cb_error_table(void) {
    if(0 == et_list_lock()) {
        if ( !link.table) {
            struct et_list *el = _et_list;
            while (el) {
                if (el->table->base == et_o2cb_error_table.base) {
                    et_list_unlock();
                    return;
                }
                el = el->next;
            }
            link.next = _et_list;
            link.table = &et_o2cb_error_table;
            _et_list = &link;
        }
        et_list_unlock();
    }
}

/* For Heimdal compatibility */
void initialize_o2cb_error_table_r(struct et_list **list)
{
    struct et_list *et, **end;

    for (end = list, et = *list; et; end = &et->next, et = et->next)
        if (et->table->msgs == text)
            return;
    et = malloc(sizeof(struct et_list));
    if (et == 0) {
            return;
    }
    et->table = &et_o2cb_error_table;
    et->next = 0;
    *end = et;
}
